Imports System.Data.SqlClient
Public Class WebForm1
	Inherits Templates.PageTemplateVB

	Protected WithEvents DataGrid1 As System.Web.UI.WebControls.DataGrid
	Private myTable As System.Data.DataTable

	Private Sub BindGrid()
		Me.LoadTable()
		Me.DataGrid1.DataSource = Me.myTable.DefaultView
		Me.DataGrid1.DataBind()
	End Sub

	Private Sub LoadTable()
		Dim row As DataRow
		Me.myTable = New DataTable()
		Me.myTable.Columns.Add(New DataColumn("Name", System.Type.GetType("System.String")))
		Me.myTable.Columns.Add(New DataColumn("Age", System.Type.GetType("System.Int32")))
		Me.myTable.Columns.Add(New DataColumn("DOB", System.Type.GetType("System.DateTime")))
		Dim i As Integer
		For i = 0 To 9
			row = Me.myTable.NewRow()
			row("Name") = "Johnny Q" + i.ToString()
			row("Age") = (i + 20)
			row("DOB") = System.DateTime.Today.AddYears(-(i + 20))
			Me.myTable.Rows.Add(row)
		Next
		Me.myTable.DefaultView.Sort = ViewState("DataGrid1Sort").ToString()
	End Sub

	' Given the old sort value and the new sort value, will return 
	' the new sort, alternating ascending and descending If the same 
	' column is chosen.  Defaults to ascending on new column sort.

	' <param name="newSort">The new sort column, typically retrieved from SortCommandEventArgs.</param>
	' <param name="oldSort">The old sort value.</param>
	' <returns>New sort expression including appropriate sort direction.</returns>

	Private Function GetNewSort(ByVal newSort As String, ByVal oldSort As String) As String
		' spaceIdx is used to get the sort column from the old sort expression,
		' which will typically contain the sort column followed by a space and 
		' a sort direction (ASC or DESC)
		Dim spaceIdx As Integer = oldSort.IndexOf(" ")
		' If there is no space, add the sort direction, which will by default be ASC
		If spaceIdx < 0 Then
			oldSort += " ASC"
			spaceIdx = oldSort.IndexOf(" ")
		End If

		If newSort.Trim() = oldSort.Substring(0, spaceIdx).Trim() Then
			If oldSort.IndexOf("ASC") >= 0 Then
				newSort += " DESC"
			Else
				newSort += " ASC"
			End If
		Else
			newSort += " ASC"
		End If

		Return newSort
	End Function

#Region " Web Form Designer Generated Code "

	'This call is required by the Web Form Designer.
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

	End Sub

	Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
		'CODEGEN: This method call is required by the Web Form Designer
		'Do not modify it using the code editor.
		InitializeComponent()
	End Sub

#End Region

	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		'Put user code to initialize the page here
		If Not Page.IsPostBack Then
			Me.Title = "Ambrose Test"
			Me.StyleSheet = "myCss.css"
			ViewState("DataGrid1Sort") = "Name ASC"
			Me.BindGrid()
    End If
	End Sub

	Private Sub DataGrid1_SortCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridSortCommandEventArgs) Handles DataGrid1.SortCommand
		ViewState("DataGrid1Sort") = GetNewSort(e.SortExpression, ViewState("DataGrid1Sort").ToString())
		Me.BindGrid()
	End Sub

End Class
